#!/usr/bin/perl -w
#

$LIST = "/srv/shingetsu/dat/stat.txt";

sub xlocaltime($) {
	my @buf = localtime($_[0]);
	return sprintf "%d-%02d-%02d %02d:%02d",
		       1900+$buf[5], $buf[4]+1, $buf[3], $buf[2], $buf[1];
}
sub file_decode($) {
	my($name) = @_;
	@_ = split /_/, $name, 2;
	$name = $_[1];
	$name =~ s/[0-9A-F][0-9A-F]/pack("C", hex($&))/eg;
	return $name;
}
sub str_encode($) {
	my ($s) = @_;
	my $encoded = '';
	foreach my $ch (split(//, $s)) {
		if ($ch =~ /[A-Za-z0-9_.\/#]/) {
			$encoded .= $ch;
		} else {
			$encoded .= '%' . sprintf("%02X", ord($ch));
		}
	}
	return $encoded;
}

open IN, $LIST or exit;
@list = ();
while (<IN>) {
	@_ = split /<>/;
	my %x = (file => $_[0], stamp => $_[1]);
	push @list, \%x;
}
close IN;
@list = sort {$$a{stamp} <=> $$b{stamp}} @list;

open OUT, "| nkf -e";
select OUT;
print "<HTML><BODY><UL>\n";
foreach (@list) {
	$file  = $$_{file};
	$stamp = $$_{stamp};
	$date  = xlocaltime $stamp;
	if ($file =~ /^(list|thread|note)_/) {
		$type = $1;
		$name = file_decode($file);
		$str  = str_encode($name);
		$uri  = "http://127.0.0.1:8000/$type.cgi/$str";
	} else {
		$name = $file;
		$uri  = "http://127.0.0.1:8000/tradgw.cgi/THREAD/$file";
	}
	$e = (-s "/srv/shingetsu/dat/$$_{file}.dat")? "o": "x";
	print "<LI>$date $e <A href='$uri'>$name</A>\n";
}
print "</UL></BODY></HTML>\n";
close IN;
close OUT;
