#!/bin/bash -e
#
# Controller Interface of shinGETsu
#
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin
LANG=C

DIR=/srv/shingetsu
PERL=/usr/bin/perl

NICE="+10"
NPROC=20

start () {
	ulimit -u $NPROC
	cd $DIR
	nice -n $NICE ./httpd.pl -v 2>&1 | /usr/local/sbin/sglog &
}

stop () {
	killall $PERL > /dev/null 2>&1
}


if ! [ -x "$DIR/httpd.pl" ]; then
	exit 0
fi

case "$1" in
    start)
	start
	;;
    stop)
	stop
	;;
    restart)
	stop
	sleep 2
	start
	;;
    *)
	echo "Usage: $0 {start|stop|restart}"
	exit 1
	;;
esac

exit 0
